import { defineStore } from "pinia";

export const useRLStore = defineStore("RL Store", {
  state: () => {
    return {
      red: Array(153600).fill(120),
      green: Array(153600).fill(120),
      blue: Array(153600).fill(120),
      width: 480,
      height: 320,
      current_time: 0,
      current_run: 0,
      current_episode: 0,
      best_reward: 0.0,
      last_user_reward: 0.0,
      trigger: false,
    };
  },
  getters: {
    getRed: (state) => state.red,
    getGreen: (state) => state.green,
    getBlue: (state) => state.blue,
    getHeight: (state) => state.height,
    getWidth: (state) => state.width,
    getCurrentTime: (state) => state.current_time,
    getCurrentRun: (state) => state.current_run,
    getCurrentEpisode: (state) => state.current_episode,
    getBestReward: (state) => state.best_reward,
    getLastUserReward: (state) => state.last_user_reward,
  },
  actions: {
    setRgbArrays(red, green, blue) {
      this.red = red;
      this.green = green;
      this.blue = blue;
      this.trigger = !this.trigger;
    },
    setDim(height, width) {
      this.height = height;
      this.width = width;
    },
    setCurrentTime(value) {
      this.current_time = value;
    },
    setCurrentRun(value) {
      this.current_run = value;
    },
    setCurrentEpisode(value) {
      this.current_episode = value;
    },
    setBestReward(value) {
      this.best_reward = value;
    },
    setLastUserReward(value) {
      this.last_user_reward = value;
    },
  },
});
